/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is NS 4.x hooks for mozilla.
 *
 * The Initial Developer of the Original Code is
 * Christian Biesinger.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#ifndef ns4hooks_h_
#define ns4hooks_h_

#include "nsISupports.h"
#include "nsIContentPolicy.h"
#include "nsString.h"
#include <objbase.h>
#include <winerror.h>

class ns4Hooks : public nsIContentPolicy {
  public:
    NS_DECL_ISUPPORTS
    NS_DECL_NSICONTENTPOLICY

    ~ns4Hooks();
    nsresult Init();
  private:
    IDispatch* GetDispatchForProtocol(nsAFlatCString& aProtocol);

    /**
     * Calls Initialize on the given IDispatch object, and returns
     * its out parameter, where 0=won't handle 1=will handle
     */
    short CallInitialize(IDispatch* aDispatch, const nsAFlatCString& aScheme,
                         const nsAFlatCString& aSpec);

    /**
     * Calls Open to start downloading
     */
    nsresult CallOpen(IDispatch* aDispatch, const nsAFlatCString& aSpec);

    HKEY mRegKey;
};

// {0CF6DFFC-C873-4748-869B-123C72E61C44}
#define NS4HOOKS_CID \
{ 0xcf6dffc, 0xc873, 0x4748, { 0x86, 0x9b, 0x12, 0x3c, 0x72, 0xe6, 0x1c, 0x44 } }

#define NS4HOOKS_CONTRACTID \
 "@mozilla.org/appcomps/ns4hooks;1"

#endif
